import sys
import os
import math
from grid import Grid
from drawcanvas import DrawCanvas


# Problem 1
def center_circle(grid, radius, ch):
    # First, put an uppercase ch in the center of the grid.
    # Next, fill in all grid locations with ch that create a circle
    # in the center of the grid with the given radius.
    # Basic idea: traverse entire grid, and if a coordinate
    # has a distance to the center of the radius, put ch in that

    # student code here:
    pass


# Problem 2

def spell_number(n):
    low_numbers = ['zero', 'one', 'two', 'three', 'four', 'five', 'six',
                   'seven', 'eight', 'nine', 'ten',
                   'eleven', 'twelve', 'thirteen', 'fourteen', 'fifteen',
                   'sixteen', 'seventeen',
                   'eighteen', 'nineteen']
    tens = ['twenty', 'thirty', 'forty', 'fifty', 'sixty', 'seventy', 'eighty',
            'ninety', 'one hundred']

    if n == 100:
        return 'one hundred'

    if n > 100:
        return str(n)

    # student code here:
    pass


# Problem 3
def lines_illusion(canvas, width, height, num_lines):
    side_line_length = width / num_lines / 3
    num_y_lines = num_lines * 5

    # Student code here:
    pass


###############################################
def main():
    os.system('') # set colorful characters on Windows
    choice = -1
    while choice < 1 or choice > 3:
        try:
            print('Please choose a problem to test:')
            print('1. Problem 1: Center Grid Circle')
            print('2. Problem 2: spell_number')
            print('3. Problem 3: Line Optical Illusion')
            choice = int(input('Choose 1 - 3: '))
        except ValueError:
            print("Please choose between 1 and 3")

    show_solution = None
    while show_solution != 'y' and show_solution != 'n':
        show_solution = input("Do you want to show the solution instead of the student answer? y/n: ")
        if len(show_solution) > 0:
            show_solution = show_solution[0].lower()
        if show_solution not in 'yn':
            print("Please select either y or n")

    show_solution = show_solution == 'y'

    if choice == 1:
        # Problem 1: testing circles
        fn = center_circle
        if show_solution:
            fn = center_circle_soln
            print("SHOWING CORRECT SOLUTION")

        width = 20
        height = 20
        radius = 5
        ch = 'x'
        grid = Grid(width, height)
        fn(grid, radius, ch)
        print_grid(grid)

    elif choice == 2:
        # Problem 2:
        fn = spell_number
        if show_solution:
            fn = spell_number_soln
            print("SHOWING CORRECT SOLUTION")

        # testing spell-number
        for i in range(101):
            print(f'spell_number({i}): {fn(i)}')

    else:
        # Problem 3: testing lines illusion
        fn = lines_illusion
        if show_solution:
            fn = lines_illusion_soln
            print("SHOWING CORRECT SOLUTION")

        width = 500
        height = 500
        num_lines = 10
        canvas = DrawCanvas(width, height, title="lines illusion")
        fn(canvas, width, height, num_lines)
        DrawCanvas.mainloop()

# Solutions:

def center_circle_soln(grid, radius, ch):
    # First, put an uppercase ch in the center of the grid.
    # Next, fill in all grid locations with ch that create a circle
    # in the center of the grid with the given radius.
    # Basic idea: traverse entire grid, and if a coordinate
    # has a distance to the center of the radius, put ch in that
    # grid location
    center_x = grid.width // 2
    center_y = grid.height // 2
    grid.set(center_x, center_y, ch.upper())

    for y in range(grid.height):
        for x in range(grid.width):
            if distance(x, y, center_x, center_y) == radius:
                grid.set(x, y, ch)


def print_grid(grid):
    for y in range(grid.height):
        for x in range(grid.width):
            ch = grid.get(x, y)
            if ch == None:
                print(' ', end='')
            else:
                print(ch, end='')
        print()


def distance(x1, y1, x2, y2):
    return int(math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)))


def lines_illusion_soln(canvas, width, height, num_lines):
    side_line_length = width / num_lines / 3
    num_y_lines = num_lines * 5

    # canvas.draw_rect(0, 0, width, height)

    for i in range(num_y_lines):
        y_start = i / num_y_lines * height
        y_end = y_start + side_line_length
        for j in range(num_lines):
            if j % 2 == 0:
                x_start = j / num_lines * width
                x_end = x_start + side_line_length
            else:
                x_end = j / num_lines * width
                x_start = x_end + side_line_length

            canvas.draw_line(x_start, y_start, x_end, y_end)


def spell_number_soln(n):
    """
    for i in $(seq 0 120); do printf ">>> spell_number($i)\n'$(./spell-number.py $i)'\n"; done
    >>> spell_number(0)
    'zero'
    >>> spell_number(1)
    'one'
    >>> spell_number(2)
    'two'
    >>> spell_number(3)
    'three'
    >>> spell_number(4)
    'four'
    >>> spell_number(5)
    'five'
    >>> spell_number(6)
    'six'
    >>> spell_number(7)
    'seven'
    >>> spell_number(8)
    'eight'
    >>> spell_number(9)
    'nine'
    >>> spell_number(10)
    'ten'
    >>> spell_number(11)
    'eleven'
    >>> spell_number(12)
    'twelve'
    >>> spell_number(13)
    'thirteen'
    >>> spell_number(14)
    'fourteen'
    >>> spell_number(15)
    'fifteen'
    >>> spell_number(16)
    'sixteen'
    >>> spell_number(17)
    'seventeen'
    >>> spell_number(18)
    'eighteen'
    >>> spell_number(19)
    'nineteen'
    >>> spell_number(20)
    'twenty'
    >>> spell_number(21)
    'twenty-one'
    >>> spell_number(22)
    'twenty-two'
    >>> spell_number(23)
    'twenty-three'
    >>> spell_number(24)
    'twenty-four'
    >>> spell_number(25)
    'twenty-five'
    >>> spell_number(26)
    'twenty-six'
    >>> spell_number(27)
    'twenty-seven'
    >>> spell_number(28)
    'twenty-eight'
    >>> spell_number(29)
    'twenty-nine'
    >>> spell_number(30)
    'thirty'
    >>> spell_number(31)
    'thirty-one'
    >>> spell_number(32)
    'thirty-two'
    >>> spell_number(33)
    'thirty-three'
    >>> spell_number(34)
    'thirty-four'
    >>> spell_number(35)
    'thirty-five'
    >>> spell_number(36)
    'thirty-six'
    >>> spell_number(37)
    'thirty-seven'
    >>> spell_number(38)
    'thirty-eight'
    >>> spell_number(39)
    'thirty-nine'
    >>> spell_number(40)
    'forty'
    >>> spell_number(41)
    'forty-one'
    >>> spell_number(42)
    'forty-two'
    >>> spell_number(43)
    'forty-three'
    >>> spell_number(44)
    'forty-four'
    >>> spell_number(45)
    'forty-five'
    >>> spell_number(46)
    'forty-six'
    >>> spell_number(47)
    'forty-seven'
    >>> spell_number(48)
    'forty-eight'
    >>> spell_number(49)
    'forty-nine'
    >>> spell_number(50)
    'fifty'
    >>> spell_number(51)
    'fifty-one'
    >>> spell_number(52)
    'fifty-two'
    >>> spell_number(53)
    'fifty-three'
    >>> spell_number(54)
    'fifty-four'
    >>> spell_number(55)
    'fifty-five'
    >>> spell_number(56)
    'fifty-six'
    >>> spell_number(57)
    'fifty-seven'
    >>> spell_number(58)
    'fifty-eight'
    >>> spell_number(59)
    'fifty-nine'
    >>> spell_number(60)
    'sixty'
    >>> spell_number(61)
    'sixty-one'
    >>> spell_number(62)
    'sixty-two'
    >>> spell_number(63)
    'sixty-three'
    >>> spell_number(64)
    'sixty-four'
    >>> spell_number(65)
    'sixty-five'
    >>> spell_number(66)
    'sixty-six'
    >>> spell_number(67)
    'sixty-seven'
    >>> spell_number(68)
    'sixty-eight'
    >>> spell_number(69)
    'sixty-nine'
    >>> spell_number(70)
    'seventy'
    >>> spell_number(71)
    'seventy-one'
    >>> spell_number(72)
    'seventy-two'
    >>> spell_number(73)
    'seventy-three'
    >>> spell_number(74)
    'seventy-four'
    >>> spell_number(75)
    'seventy-five'
    >>> spell_number(76)
    'seventy-six'
    >>> spell_number(77)
    'seventy-seven'
    >>> spell_number(78)
    'seventy-eight'
    >>> spell_number(79)
    'seventy-nine'
    >>> spell_number(80)
    'eighty'
    >>> spell_number(81)
    'eighty-one'
    >>> spell_number(82)
    'eighty-two'
    >>> spell_number(83)
    'eighty-three'
    >>> spell_number(84)
    'eighty-four'
    >>> spell_number(85)
    'eighty-five'
    >>> spell_number(86)
    'eighty-six'
    >>> spell_number(87)
    'eighty-seven'
    >>> spell_number(88)
    'eighty-eight'
    >>> spell_number(89)
    'eighty-nine'
    >>> spell_number(90)
    'ninety'
    >>> spell_number(91)
    'ninety-one'
    >>> spell_number(92)
    'ninety-two'
    >>> spell_number(93)
    'ninety-three'
    >>> spell_number(94)
    'ninety-four'
    >>> spell_number(95)
    'ninety-five'
    >>> spell_number(96)
    'ninety-six'
    >>> spell_number(97)
    'ninety-seven'
    >>> spell_number(98)
    'ninety-eight'
    >>> spell_number(99)
    'ninety-nine'
    >>> spell_number(100)
    'one hundred'
    >>> spell_number(101)
    '101'
    >>> spell_number(102)
    '102'
    >>> spell_number(103)
    '103'
    >>> spell_number(104)
    '104'
    >>> spell_number(105)
    '105'
    >>> spell_number(106)
    '106'
    >>> spell_number(107)
    '107'
    >>> spell_number(108)
    '108'
    >>> spell_number(109)
    '109'
    >>> spell_number(110)
    '110'
    >>> spell_number(111)
    '111'
    >>> spell_number(112)
    '112'
    >>> spell_number(113)
    '113'
    >>> spell_number(114)
    '114'
    >>> spell_number(115)
    '115'
    >>> spell_number(116)
    '116'
    >>> spell_number(117)
    '117'
    >>> spell_number(118)
    '118'
    >>> spell_number(119)
    '119'
    >>> spell_number(120)
    '120'
    """
    if n == 100:
        return 'one hundred'

    if n > 100:
        return str(n)

    low_numbers = ['zero', 'one', 'two', 'three', 'four', 'five', 'six',
                   'seven', 'eight', 'nine', 'ten',
                   'eleven', 'twelve', 'thirteen', 'fourteen', 'fifteen',
                   'sixteen', 'seventeen',
                   'eighteen', 'nineteen']
    tens = ['twenty', 'thirty', 'forty', 'fifty', 'sixty', 'seventy', 'eighty',
            'ninety', 'one hundred']

    if n < 20:
        return low_numbers[n]

    ones_digit = n % 10
    tens_digit = n // 10

    word = tens[tens_digit - 2]

    if ones_digit > 0:
        word += f'-{low_numbers[ones_digit]}'
        # alternate: word += '-' + low_numbers[ones_digit]

    return word


if __name__ == "__main__":
    main()
